'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _configManager = require('../config/configManager');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var addCommand = function () {
	var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
		var questions, configItem;
		return regeneratorRuntime.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						questions = [{
							type: 'input',
							name: 'name',
							message: 'Boilerplate name => ',
							validate: function validate(value) {
								var pass = value.match(/\w+/);
								if (!pass) {
									return 'The Boilerplate name should NOT be empty, please input!';
								}

								if ((0, _configManager.configItemExist)(value)) {
									return "The Boilerplate with same name already exist!";
								}

								return true;
							}
						}, {
							type: 'input',
							name: 'repo',
							message: 'Boilerplate repo address => ',
							validate: function validate(value) {
								var pass = value.match(/((git|ssh|http(s)?)|(git@[\w.]+))(:(\/\/)?)([\w.@:/\-~]+)(\.git)(\/)?/);
								if (pass) {
									return true;
								}

								return 'Please input a valid repo url!';
							}
						}, {
							type: 'input',
							name: 'branch',
							message: 'Boilerplate branch => ',
							default: function _default() {
								return 'master';
							}
						}];
						_context.next = 3;
						return _inquirer2.default.prompt(questions);

					case 3:
						configItem = _context.sent;
						_context.next = 6;
						return (0, _configManager.addConfigItem)(configItem);

					case 6:

						console.log(_chalk2.default.green('Success!') + ' - ' + _chalk2.default.white.bgGreen.bold(configItem.name + ' (' + configItem.branch + ')') + ' was added!');

					case 7:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, undefined);
	}));

	return function addCommand() {
		return _ref.apply(this, arguments);
	};
}();

exports.default = addCommand;