'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _configManager = require('../config/configManager');

var _common = require('./common');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var deleteCommand = function () {
	var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
		var configList, selected, selectedIdx, deletedConfigItemName;
		return regeneratorRuntime.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						configList = (0, _configManager.loadConfig)()['list'];


						(0, _common.displayConfigList)(configList);

						_context.next = 4;
						return _inquirer2.default.prompt([{
							type: 'input',
							message: 'Delete item (quit with invalid idx) => ',
							name: 'idx'
						}]);

					case 4:
						selected = _context.sent;
						selectedIdx = parseInt(selected.idx);

						if (!(!isNaN(selectedIdx) && selectedIdx >= 1 && selectedIdx <= configList.length)) {
							_context.next = 13;
							break;
						}

						_context.next = 9;
						return (0, _configManager.deleteConfigItem)(selectedIdx - 1);

					case 9:
						deletedConfigItemName = _context.sent;

						console.log(_chalk2.default.green('Success!') + ' - ' + _chalk2.default.white.bgRed.bold(configItem.name + ' (' + configItem.branch + ')') + ' was deleted!');
						_context.next = 14;
						break;

					case 13:
						console.log(_chalk2.default.red('Quit with invalid idx!'));

					case 14:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, undefined);
	}));

	return function deleteCommand() {
		return _ref.apply(this, arguments);
	};
}();

exports.default = deleteCommand;