'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _execa = require('execa');

var _execa2 = _interopRequireDefault(_execa);

var _listr = require('listr');

var _listr2 = _interopRequireDefault(_listr);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _file = require('../utils/file');

var _configManager = require('../config/configManager');

var _constants = require('../config/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var cwd = process.cwd();

var gitCloneTask = function () {
	var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(ctx) {
		var name, repo, selectedBoilerplatePath;
		return regeneratorRuntime.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						name = ctx.name, repo = ctx.repo, selectedBoilerplatePath = ctx.selectedBoilerplatePath;


						process.chdir(_constants.SHAMROCK_HOME);

						_context.next = 4;
						return (0, _execa2.default)('git', ['clone', repo, selectedBoilerplatePath]);

					case 4:

						ctx.withClone = true;

					case 5:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, undefined);
	}));

	return function gitCloneTask(_x) {
		return _ref.apply(this, arguments);
	};
}();

var gitPullTask = function () {
	var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(ctx) {
		var selectedBoilerplatePath;
		return regeneratorRuntime.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						selectedBoilerplatePath = ctx.selectedBoilerplatePath;


						process.chdir(selectedBoilerplatePath);
						_context2.next = 4;
						return (0, _execa2.default)('git', ['pull']);

					case 4:
					case 'end':
						return _context2.stop();
				}
			}
		}, _callee2, undefined);
	}));

	return function gitPullTask(_x2) {
		return _ref2.apply(this, arguments);
	};
}();

var runInitTasks = function () {
	var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(name, repo, branch) {
		var selectedBoilerplatePath, selectedBladeFilePath, initTaskCtx, gitTasks, packageTasks, shamrockTasks;
		return regeneratorRuntime.wrap(function _callee9$(_context9) {
			while (1) {
				switch (_context9.prev = _context9.next) {
					case 0:
						selectedBoilerplatePath = _path2.default.join(_constants.SHAMROCK_HOME, name);
						selectedBladeFilePath = _path2.default.join(_constants.SHAMROCK_HOME, name, _constants.PROJECT_SHAMROCK_SCRIPT);
						initTaskCtx = {
							name: name,
							repo: repo,
							branch: branch,
							selectedBoilerplatePath: selectedBoilerplatePath,
							selectedBladeFilePath: selectedBladeFilePath,
							withClone: true,
							yarn: true
						};
						gitTasks = new _listr2.default([{
							title: 'Clone boilerplate',
							task: gitCloneTask,
							skip: function () {
								var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(ctx) {
									return regeneratorRuntime.wrap(function _callee3$(_context3) {
										while (1) {
											switch (_context3.prev = _context3.next) {
												case 0:
													_context3.next = 2;
													return (0, _file.dirExist)(ctx.selectedBoilerplatePath);

												case 2:
													if (!_context3.sent) {
														_context3.next = 4;
														break;
													}

													return _context3.abrupt('return', ctx.name + ' already exist!');

												case 4:
												case 'end':
													return _context3.stop();
											}
										}
									}, _callee3, undefined);
								}));

								return function skip(_x6) {
									return _ref4.apply(this, arguments);
								};
							}()
						}, {
							title: 'Pull the latest code',
							enabled: function enabled(ctx) {
								return ctx.withClone === false;
							},
							task: gitPullTask
						}, {
							title: 'Switch branch',
							task: function () {
								var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(ctx) {
									return regeneratorRuntime.wrap(function _callee4$(_context4) {
										while (1) {
											switch (_context4.prev = _context4.next) {
												case 0:
													process.chdir(ctx.selectedBoilerplatePath);
													_context4.next = 3;
													return (0, _execa2.default)('git', ['checkout', branch]);

												case 3:
												case 'end':
													return _context4.stop();
											}
										}
									}, _callee4, undefined);
								}));

								return function task(_x7) {
									return _ref5.apply(this, arguments);
								};
							}()
						}]);
						packageTasks = new _listr2.default([{
							title: 'Install package dependencies with yarn',
							task: function () {
								var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(ctx, _task) {
									return regeneratorRuntime.wrap(function _callee5$(_context5) {
										while (1) {
											switch (_context5.prev = _context5.next) {
												case 0:
													process.chdir(ctx.selectedBoilerplatePath);
													_context5.prev = 1;
													_context5.next = 4;
													return (0, _execa2.default)('yarn');

												case 4:
													_context5.next = 10;
													break;

												case 6:
													_context5.prev = 6;
													_context5.t0 = _context5['catch'](1);

													ctx.yarn = false;
													_task.skip('yarn is not available');

												case 10:
												case 'end':
													return _context5.stop();
											}
										}
									}, _callee5, undefined, [[1, 6]]);
								}));

								return function task(_x8, _x9) {
									return _ref6.apply(this, arguments);
								};
							}(),
							skip: function () {
								var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(ctx) {
									return regeneratorRuntime.wrap(function _callee6$(_context6) {
										while (1) {
											switch (_context6.prev = _context6.next) {
												case 0:
													_context6.next = 2;
													return (0, _file.fileExist)(_path2.default.join(ctx.selectedBoilerplatePath, 'yarn.lock'));

												case 2:
													if (_context6.sent) {
														_context6.next = 5;
														break;
													}

													ctx.yarn = false;
													return _context6.abrupt('return', 'yarn.lock is not exist');

												case 5:
												case 'end':
													return _context6.stop();
											}
										}
									}, _callee6, undefined);
								}));

								return function skip(_x10) {
									return _ref7.apply(this, arguments);
								};
							}()
						}, {
							title: 'Install package dependencies with npm',
							enabled: function enabled(ctx) {
								return ctx.yarn === false;
							},
							task: function () {
								var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(ctx, _task2) {
									return regeneratorRuntime.wrap(function _callee7$(_context7) {
										while (1) {
											switch (_context7.prev = _context7.next) {
												case 0:
													process.chdir(ctx.selectedBoilerplatePath);
													_context7.next = 3;
													return (0, _execa2.default)('npm', ['install']);

												case 3:
												case 'end':
													return _context7.stop();
											}
										}
									}, _callee7, undefined);
								}));

								return function task(_x11, _x12) {
									return _ref8.apply(this, arguments);
								};
							}()
						}]);
						_context9.prev = 5;
						_context9.next = 8;
						return gitTasks.run(initTaskCtx);

					case 8:
						initTaskCtx = _context9.sent;
						_context9.next = 11;
						return packageTasks.run(initTaskCtx);

					case 11:
						initTaskCtx = _context9.sent;
						_context9.next = 14;
						return (0, _file.fileExist)(selectedBladeFilePath);

					case 14:
						if (!_context9.sent) {
							_context9.next = 18;
							break;
						}

						shamrockTasks = new _listr2.default([{
							title: 'Run shamrock.js',
							task: function () {
								var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
									return regeneratorRuntime.wrap(function _callee8$(_context8) {
										while (1) {
											switch (_context8.prev = _context8.next) {
												case 0:
												case 'end':
													return _context8.stop();
											}
										}
									}, _callee8, undefined);
								}));

								return function task() {
									return _ref9.apply(this, arguments);
								};
							}()
						}]);
						_context9.next = 18;
						return shamrockTasks.run(initTaskCtx);

					case 18:
						_context9.next = 23;
						break;

					case 20:
						_context9.prev = 20;
						_context9.t0 = _context9['catch'](5);

						console.error(_chalk2.default.red(_context9.t0));

					case 23:
					case 'end':
						return _context9.stop();
				}
			}
		}, _callee9, undefined, [[5, 20]]);
	}));

	return function runInitTasks(_x3, _x4, _x5) {
		return _ref3.apply(this, arguments);
	};
}();

var initCommand = function () {
	var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
		var configList, configObjectList, selectedConfig, selectedConfigItem, name, repo, branch;
		return regeneratorRuntime.wrap(function _callee10$(_context10) {
			while (1) {
				switch (_context10.prev = _context10.next) {
					case 0:
						configList = (0, _configManager.loadConfig)()['list'];
						configObjectList = configList.map(function (configItme) {
							return {
								name: configItme.name + ' (' + configItme.branch + ')',
								value: configItme.name
							};
						});

						if (!(configList.length === 0)) {
							_context10.next = 5;
							break;
						}

						console.log(_chalk2.default.yellow('No available boilerplate'));
						return _context10.abrupt('return');

					case 5:
						_context10.next = 7;
						return _inquirer2.default.prompt([{
							type: 'list',
							name: 'name',
							message: 'Select boilerplate to init project',
							choices: configObjectList
						}]);

					case 7:
						selectedConfig = _context10.sent;
						selectedConfigItem = configList.find(function (configItme) {
							return configItme.name === selectedConfig.name;
						});
						name = selectedConfigItem.name, repo = selectedConfigItem.repo, branch = selectedConfigItem.branch;


						runInitTasks(name, repo, branch);

					case 11:
					case 'end':
						return _context10.stop();
				}
			}
		}, _callee10, undefined);
	}));

	return function initCommand() {
		return _ref10.apply(this, arguments);
	};
}();

exports.default = initCommand;