'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _configManager = require('../config/configManager');

var _common = require('./common');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var listCommand = function () {
	var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
		var configList, selected, selectedIdx;
		return regeneratorRuntime.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						configList = (0, _configManager.loadConfig)()['list'];


						(0, _common.displayConfigList)(configList);

					case 2:
						if (!true) {
							_context.next = 15;
							break;
						}

						_context.next = 5;
						return _inquirer2.default.prompt([{
							type: 'input',
							message: 'Show detail of (quit with invalid idx) => ',
							name: 'idx'
						}]);

					case 5:
						selected = _context.sent;
						selectedIdx = parseInt(selected.idx);

						if (!(!isNaN(selectedIdx) && selectedIdx >= 1 && selectedIdx <= configList.length)) {
							_context.next = 11;
							break;
						}

						console.log(_chalk2.default.magenta(JSON.stringify(configList[selectedIdx - 1], null, '  ')));
						_context.next = 13;
						break;

					case 11:
						console.log(_chalk2.default.red('Quit with invalid idx!'));
						return _context.abrupt('break', 15);

					case 13:
						_context.next = 2;
						break;

					case 15:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, undefined);
	}));

	return function listCommand() {
		return _ref.apply(this, arguments);
	};
}();

exports.default = listCommand;