'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.deleteConfigItem = exports.addConfigItem = exports.configItemExist = exports.saveConfig = exports.loadConfig = exports.createConfigIfNotExist = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _file = require('../utils/file');

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var configFilePath = _path2.default.join(_constants.SHAMROCK_HOME, _constants.CONFIG_FILE_NAME);

var createConfigIfNotExist = exports.createConfigIfNotExist = function () {
	var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
		return regeneratorRuntime.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						_context.next = 2;
						return (0, _file.fileExist)(configFilePath);

					case 2:
						if (_context.sent) {
							_context.next = 7;
							break;
						}

						_context.next = 5;
						return _fsExtra2.default.ensureFile(configFilePath);

					case 5:
						_context.next = 7;
						return saveConfig(_constants.DEFAULT_CONFIGS);

					case 7:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, undefined);
	}));

	return function createConfigIfNotExist() {
		return _ref.apply(this, arguments);
	};
}();

var loadConfig = exports.loadConfig = function loadConfig() {
	return require(configFilePath);
};

var saveConfig = exports.saveConfig = function () {
	var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(json) {
		return regeneratorRuntime.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						_context2.next = 2;
						return _fsExtra2.default.outputJson(configFilePath, json, { spaces: 4 });

					case 2:
					case 'end':
						return _context2.stop();
				}
			}
		}, _callee2, undefined);
	}));

	return function saveConfig(_x) {
		return _ref2.apply(this, arguments);
	};
}();

var configItemExist = exports.configItemExist = function configItemExist(configName) {
	var configObject = loadConfig();

	var found = configObject['list'].find(function (configItem) {
		return configItem.name === configName;
	});

	return found ? true : false;
};

var addConfigItem = exports.addConfigItem = function () {
	var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(configItem) {
		var configObject;
		return regeneratorRuntime.wrap(function _callee3$(_context3) {
			while (1) {
				switch (_context3.prev = _context3.next) {
					case 0:
						configObject = loadConfig();

						configObject['list'].push(configItem);

						_context3.next = 4;
						return saveConfig(configObject);

					case 4:
					case 'end':
						return _context3.stop();
				}
			}
		}, _callee3, undefined);
	}));

	return function addConfigItem(_x2) {
		return _ref3.apply(this, arguments);
	};
}();

var deleteConfigItem = exports.deleteConfigItem = function () {
	var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(idx) {
		var configObject, deletedConfigItemName;
		return regeneratorRuntime.wrap(function _callee4$(_context4) {
			while (1) {
				switch (_context4.prev = _context4.next) {
					case 0:
						configObject = loadConfig();
						deletedConfigItemName = configObject.list[idx].name;

						configObject['list'].splice(idx, 1);

						_context4.next = 5;
						return saveConfig(configObject);

					case 5:
						return _context4.abrupt('return', deletedConfigItemName);

					case 6:
					case 'end':
						return _context4.stop();
				}
			}
		}, _callee4, undefined);
	}));

	return function deleteConfigItem(_x3) {
		return _ref4.apply(this, arguments);
	};
}();